<?php
// galupki.de (c) Jrgen Galupki 10.2005
// liefert eine  .vcs-Datei mit den angelieferten Daten zurueck
// kann man direkt z.B. in Outlook importieren


if (!isset( $summary )) {
   echo "liefert ein vCalendar File aus (Test nur mit Outlook)<br>";
   echo "<b>usage:</b> ...<br>";
   echo "?summary=betreff&details=Zeile1\\rZeile2<br>&stunde=hh&minute=mm&tag=tt&monat=mm&jahr=jjjj<br>&bstunde=hh&bminute=mm&btag=tt&bmonat=mm&bjahr=jjjj<br>";
   echo "&alarm=minuten<br>";
   echo "&organizer=mailadresse&attendee=mailadresse";
   die();
}





$version = "1.0";
$method = "PUBLISH";   

if (!isset( $stunde ))  $stunde  = date("H");
$stunde = htmlspecialchars($stunde);
if (!isset( $minute ))  $minute  = date("i");
$minute = htmlspecialchars($minute);
if (!isset( $monat ) )  $monat   = date("m");
$monat = htmlspecialchars($monat);
if (!isset( $tag )   )  $tag     = date("d");
$tag = htmlspecialchars($tag);
if (!isset( $jahr )  )  $jahr    = date("Y");
$jahr = htmlspecialchars($jahr);
if (!isset( $details )) $details = "";
$details = htmlspecialchars($details);
if (!isset( $bstunde )) $bstunde = $stunde;
$bstunde = htmlspecialchars($bstunde);
if (!isset( $bminute )) $bminute = $minute;
$bminute = htmlspecialchars($bminute);
if (!isset( $bmonat ) ) $bmonat  = $monat;
$bmonat = htmlspecialchars($bmonat);
if (!isset( $btag )   ) $btag    = $tag;
$btag = htmlspecialchars($btag);
if (!isset( $bjahr )  ) $bjahr   = $jahr;
$bjahr = htmlspecialchars($bjahr);


if (!isset( $alarm ) ) {
   $alarm = "";
}  else {
   $alarm = htmlspecialchars($alarm);
   $alarm = "BEGIN:VALARM\nTRIGGER:-PT".$alarm."M\nACTION:DISPLAY\nDESCRIPTION:Reminder\nEND:VALARM\n";   // Erinnerung in Minuten
   $version = "2.0";
}


if (!isset( $organizer ) ) {
   $organizer = "";
   $attendee = "";
}  else {
   $organizer = htmlspecialchars($organizer);
   $organizer = "ORGANIZER:MAILTO:".$organizer."\n";   // Organizer
   if ( !isset( $attendee ) ) {
      echo "Empfnger-EMail-Adresse \$attendee muss ebenfalls angegeben werden";
      die();
   }  else {
      $attendee = htmlspecialchars($attendee);
      $attendee = "ATTENDEE;CN=\"$attendee\";ROLE=REQ-PARTICIPANT;RSVP=TRUE:MAILTO:$attendee\n";
   }
   $method    = "REQUEST";
   $version   = "2.0";
}


$id = str_replace(".", "", microtime());
$id = str_replace(" ", "", $id);

$eventstart = mktime ( $stunde , $minute , 00, $monat , $tag , $jahr );
$eventend   = mktime ( $bstunde , $bminute , 00, $bmonat , $btag , $bjahr );

$Filename = "Kalender_Event_$id".".vcs";

header("Content-Type: text/x-vCalendar");
header("Content-Disposition: inline; filename=$Filename");
$summary = htmlspecialchars($summary);
$summary  = imap_8bit ( $summary );

$DescDump = str_replace("\\r", "\r", $details);         // je nach Apache-Config ggfs. \\\\r
$DescDump = imap_8bit ( $DescDump );

if ( $minute=="" or $stunde=="" ) {
   $vCalStart = ";VALUE=DATE:".date("Ymd\T000000", $eventstart);
}  else {
   $vCalStart = ":".date("Ymd\THi00", $eventstart);
}

if ( $bminute=="" or $bstunde=="" ) {
   $vCalEnd = ";VALUE=DATE:".date("Ymd\T000000", $eventend);
}  else {
   $vCalEnd = ":".date("Ymd\THi00", $eventend);
}

?>
BEGIN:VCALENDAR
PRODID:-//php vCalendar//Generator by galupki.de MIMEDIR//EN
VERSION:<?php echo $version . "\n"; ?>
METHOD:<?php echo $method . "\n"; ?><?php echo $organizer; ?><?php echo $attendee; ?>
BEGIN:VEVENT
DTSTART<?php echo $vCalStart . "\n"; ?>
DTSTAMP:<?php echo date("Ymd\THis") . "\n"; ?>
DTEND<?php echo $vCalEnd . "\n"; ?>
UID:<?php echo $id . "\n"; ?>
DESCRIPTION;ENCODING=QUOTED-PRINTABLE:<?php echo $DescDump . "\n"; ?>
SUMMARY;ENCODING=QUOTED-PRINTABLE:<?php echo $summary . "\n"; ?><?php echo $alarm; ?>
END:VEVENT
END:VCALENDAR
