<?php
/* ==================================================================================================================
Outlook Termindatei einlesen, ggf. nur bestimmte Eintrge selektieren und die
Outlook-Termine umsetzen in eine csvedit.OutlookKalender.csv

outlookkalender.php beta 1
(c) 2006 ff - Version vom 23.12.2006 Juergen Galupki http://galupki.de - Lizenz siehe /Kontakt -seite


Ja wozu eigentlich?
- Webzugriff von berall her auf die eigenen aktuellsten Outlookdaten ohne andere Tools oder Exchange
- Einige Terminarten (z.B. Ostern, abhngig von Ostern) kennt Outlook nicht (kann man einzeln auffhren, klar)
- Jubilumsangaben (z.B. welches Jubilum bei Hochzeitstag, Alter bei Geburtstagen) zeigt Outlook nicht an
- Monatskalender im Outlook im Standard nicht allzu schn
- unterwegs (ohne PDA fr ActiveSync oder Outlook-Web-Zugriff z.B. vom Exchange) knnen Termine vorerfasst
  und spaeter durch einen Klick ins Outlook "wieder vor Ort" bernommen werden

--> deswegen luft dieses Verfahren bei mir, und der Web-Monatskalender wird mittels activeDesktop(?) 
    auf dem Desktop jederzeit in aktueller Form angezeigt. Alle Termine werden wenn mglich im Outlook 
    erfasst...


Generelle Arbeitsweise: 
- ein Script liest alle vorhandenen Termine aus persnlichem Outlook-Kalender aus in ein File       (VBscript...)
- File wird transportiert in Arbeitsverzeichnis (z.B. mit FTP auf einen Webserver)                  (GeplanteTasks)
- File wird von DIESEM Script umgesetzt in eine fr meine Klassen/Routinen auswertbare Termindatei  (cronjob)
- Termindatei wird z.B. als Monatskalender (...) vom Kalenderscript angezeigt                       (Browser)


Vom Script NICHT UNTERSTTZT (weil ichs bisher nicht brauche), aber in Outlook mglich vorzugeben:

monatlich, bestimmter Tag im Monat mit einem Monats-Intervall grer als 1 (bei Typ MONTHLY)
monatlich, Wochentag n.-te Woche mit einem Monats-Intervall grer als 1 (bei Typ MONTHLYnTH)
Abhilfe:
=> codieren (leicht mglich bei jedem 2, 3, 4, 6 Monat) ODER als "Kruecke" in Outlook schon mehrere Termine anlegen!

Die EntryId wird nicht bernommen (ebenfalls bisher kein Bedarf, da keine Synchronisation geplant...)

Kategorien "Jahrestag", "Jubilum" sollten im Outlook in die Hauptkategorienliste aufgenommen werden, oder
Jubilen/Jahrestage sind durch einen "*" an 1.er Stelle Subject zu kennzeichnen. Das bewirkt, dass bei der
Anzeige von so gekennzeichneten Terminen in Klammern die Jahreszahl (z.B. bei Geburtstagen das Alter)
ausgegeben wird.

Der Code ist noch nicht optimiert (z.B. Datmer bilden) und nicht sonderlich gut ausgetestet...
todo: Weiteres auslagern in Funktionen (z.B. von/bis Datmer/Zeit parsen)

Aufbau (jeweils Trennzeichen ";")...

Outlookdatei ======================================================================================================
EntryId 0; Subject 1; Location 2; Start 3; End 4; AllDayEvent 5; Duration 6; ReminderMinutes 7; 
Categories 8; Importance 9; MeetingStatus 10; ResponseStatus 11; Sensitivity 12; LastModificationTime 13; Serie 14;
Ausnahmen 15; StartSerie 16; AllDayEvent_Time 17; EndSerie 18; Type 19; Monat_Interval 20; Day_Instanz 21;
DayOfWeekMask 22

Termindatei =======================================================================================================
Feiertag 0; Typ 1; anznr 2; vontag 3; vonmonat 4; vonjahr 5; bistag 6; bismonat 7; bisjahr 8; 
wiederholung 9; differenz 10; ausnahme 11; layout 12; frei 13; regional 14; nottage 15; quitdate 16; 
notiz 17; modified 18
================================================================================================================== */

// das Script hier vor dem ersten Aufruf anpassen:

$debug              = false;                                          // uebertragene Datensaetze rausscheiben

$serverhtdoc        = "/www/htdocs";                                  // htdocs-root liegt auf dem Server hier...
$incoming           = "$serverhtdoc/wiki/upload/";                    // das Work-Dir (writeable!) mit den Dateien

$outlookfile        = $serverhtdoc."/incoming/Outlook_Termin_Definitionen.csv";  // in
$terminfile         = $incoming . "csvedit.OutlookKalender.csv";      // out


// einschrnken von zu bernehmenden Terminen nach Bedarf:

// calfile:         sind Termine (via Subject) in diesem Kalenderfile vorhanden, werden Termine mit diesen Subjects 
//                  aus der Outlookdatei nicht in die Ausgabe bernommen 
//                  existiert diese Datei gar nicht -> alle bernehmen, ansonsten strpos() aufs Subject
//
//                  Die nachfolgenden Parameter beziehen sich auf die Eingabedateifelder Categories und Sensititvity 
//                  Es kann keine (=leer) oder genau ein Wert vorgegeben werden (Gross-/Klein/Umlaute beachten!)
//                  mgliche Werte Category:    Hauptkategorienliste, kann man anpassen und eigene Kategorien vergeben!
//                  mgliche Werte Sensitivity: Confidential,Personal,Private (u.a. Ankreuzkstchen "Privat"!)
//                   
// include...:      wenn gesetzt, werden nur Termine bernommen, die dieser einen Kategorie angehren
// exclude...:      wenn gesetzt, werden Termine mit dieser einen Kategorie ausgeschlossen

$wikicalfile         = $incoming . "csvedit.WikiKalender.csv";         // WikiKalender (zum Ausschluss von Terminen)

#$include_category   = "Private";                                      // Termine mit genau dieser Kategorie/Sensitivity 
#$include_category   = "Outlook";                                      // Termine mit genau dieser Kategorie/Sensitivity 
 $include_category   = "";                                             // leer = alle Termine

#$exclude_category   = "Private";                                      // Termine mit dieser Kategorie/Sensitivity
#$exclude_category   = "Feiertag";                                     // Termine mit dieser Kategorie/Sensitivity
 $exclude_category   = "";                                             // Termine mit dieser Kategorie/Sensitivity



include("$serverhtdoc/kalender/lib/kalender.class.php");              // php Kalender-Klasse



//keine Aenderungen ab hier (evtl.: Suche nach "")... ==========================================================


$ueberschrift       = "Feiertag;Typ;anznr;vontag;vonmonat;vonjahr;bistag;bismonat;bisjahr;"
                    . "wiederholung;differenz;ausnahme;layout;frei;regional;nottage;quitdate;notiz;modified";

$ft = new kalender;


  echo "\n<p>outlookkalender.php setzt Termine um ($outlookfile -> $terminfile)...</p>";


// auszuschliessende Termine ( Vorsicht, nur ber das Subject - evtl. ein bisschen riskant, Liste kontrollieren!...)
  unset($ausschluss);
  $wikical = fopen($wikicalfile, "r");
  if ( flock($wikical, 1) ) {                    
     while ($satz =  fgets($wikical, 2048) ) {
           $data = explode(";", trim($satz), 3);
           $ausschluss[] = $data[0];             // aufbau eines Arrays mit den vorhandenen Subjects
     }
     fclose($wikical);
    $ausanz = count($ausschluss);
    echo "\n<br />$ausanz Subjects zum Ausschluss (aus $wikicalfile) werden je Termin berprft.\n<br />";
  } else {
    $ausanz = 0;
  }
    


// aus noch aktuellem Terminfile Outlook-unbekannte Termine retten
  unset($pending);
  $wikical = fopen($terminfile, "r");
  if ( flock($wikical, 1) ) {                    
     $firstsatz = true;
     while ($satz =  fgets($wikical, 2048) ) {
           if ( $firstsatz==true ) {
              $firstsatz = false;
              continue;
           }
           $data = explode(";", trim($satz));
           if ( substr($data[17],0,5)!="->OL!" 
                AND trim($data[0])!="" ) {
              $pending[] = $satz;                  // treffer, kommt anscheinend NICHT aus Outlook
           }                                       // sondern wurde manuell online erfasst!
     }
     fclose($wikical);
    $pendinganz = count($pending);
    echo "\n<br />$pendinganz (nur) lokal erfasste Termine (aus $terminfile) werden je Termin berprft.\n<br />";
  } else {
    $pendinganz = 0;
  }
    

// und los...

  $old = fopen($outlookfile, "r") or die("Abort: Kann die Quelldatei $outlookfile nicht locken.");

  $new = fopen($terminfile.".new", "wb");
  flock($new, 2) or die("Abort: Kann die Zieldatei $terminfile nicht locken.");
  
  $satz = trim($ueberschrift)."\r\n";
  if (!fwrite($new, $satz)) {
     fclose($old);
     fclose($new);
     unlink($oldfile.".new");
     die("Abort: Fehler schon beim schreiben der Ueberschrift, alte Datei $terminfile bleibt, sofern vorhanden.");
  }
  

  $lineno = 0;
  $lineok = 0;
  while ( $satz =  fgets($old, 2048) ) {

// Outlooksatz nach $data[] expandieren (die Termindatenfelder werden aufgebaut in den Variablen $f:n:)
        $data = explode(";", trim($satz));
        $lineno++;
        $num = count($data);
        
        if ($lineno==1) {
           continue;       // es wird immer eine berschrift angenommen und geskippt!
        }


// auszuschliessende Saetze erkennen versuchen, weil schon im WikiKalender vorhanden! NUR nach Subject!!! 
   if ($ausanz>0) {
      for ($i = 0; $i < $ausanz; $i++) {
          $pos = strpos(" ".$data[1], $ausschluss[$i]);
          if ( $pos!==false ) {           
             $len1 = strlen(trim($data[1]));         //  diese beiden Zeilen und das umschliessende IF
             $len2 = strlen(trim($ausschluss[$i]));  // in Kommentar setzen um die Prfung etwas zu entschrfen
             if ( $len1==$len2 ) {
                echo "\n<br />skip $lineno: ".$ausschluss[$i]." [Ausschlussliste] -> ".$data[1]." [Kalender]";
                continue 2;  // wenn ein Subject vom vorhandenen WikiKalender vorkommt, den Satz vergessen!
             }
          }
      }
   }


// einzuschliessende Stze nach Category oder Sensitivity
   if ($include_category!="") {
      $pos = strpos(" ".$data[8], $include_category);
      if ( $pos===false ) {
         $pos = strpos(" ".$data[12], $include_category);
         if ( $pos===false ) {
            echo "\n<br />skip $lineno: ".$include_category." -> ".$data[8]." ".$data[12]." [i Category/Sensitivity]";
            continue;
         }
      }
   }

// auszuschliessende Stze nach Category oder Sensitivity
   if ($exclude_category!="") {
      $pos = strpos(" ".$data[8], $exclude_category);
      if ( $pos===false ) {
         $pos = strpos(" ".$data[12], $exclude_category);
         if ( $pos===false ) {
//          alles ok
         }  else {
            echo "\n<br />skip $lineno: ".$exclude_category." -> ".$data[8]." ".$data[12]." [e Category/Sensitivity]";
            continue;
         }
      }  else {
         echo "\n<br />skip $lineno: ".$exclude_category." -> ".$data[8]." ".$data[12]." [e Category/Sensitivity]";
         continue;
      }
   }


        
// aufraeumen, neuer Termin
   unset($vondatuhr);
   unset($bisdatuhr);
   unset($von);
   unset($bis);
   unset($zeit);
   unset($meeting);
   for ($c=0; $c <= 18; $c++) {
       $vname = "f$c";
       unset($$vname);
   }

// und los gehts...
   $f0 = $data[1]; // subject 
   if ($data[2]!="") {
      $f0 .= " [" . $data[2] . "]"; // subject [Location] 
   }

   $vondatuhr = explode(" ", $data[3]);
   $von       = explode(".", $vondatuhr[0]);
   $f3 = $von[0]; // tag von
   $f4 = $von[1]; // monat von
   $f5 = $von[2]; // jahr von
   if (isset($vondatuhr[1])) {
      $zeit = substr($vondatuhr[1],0,5);
   }
   
   $bisdatuhr = explode(" ", $data[4]);
   $bis =     explode(".", $bisdatuhr[0]);
   $f6 = $bis[0]; // tag bis
   $f7 = $bis[1]; // monat bis
   $f8 = $bis[2]; // jahr bis
   if (isset($bisdatuhr[1])
       AND $vondatuhr[1]!=$bisdatuhr[1]) {
      $zeit .= "-" . substr($bisdatuhr[1],0,5);
   }


// AllDayEvent-Patch 
   if ($data[5]=="AllDayEvent") { // 1440 Minuten = 1 Tag, aber von-Datum != bis-Datum ?! mehrere Tage entsprechend...
#     if ($data[6]=="1440") { // Outlook/Exchange-Problem - oder mein Problem?: +1 Tag - auf Nummer Sicher
#        $f6 = $f3;
#        $f7 = $f4;
#        $f8 = $f5;
#     }

// genereller Fix: bei einem AllDayEvent das Endedatum ignorieren, und stattdessen
// ueber die Duration des Termins ausgerechnet/gesetzt wird!
      $ft->DatumsRechnung($f5, $f4, $f3, ($data[6]/60/24)-1); // Startdatum plus Duration in Tagen abzglich 1
      if ($f6!=$ft->tag) {
         $taged = $data[6]/60/24;
#     echo "\n<br />$lineno AllDayEventPatch: $f3.$f4.$f5 - $f6.$f7.$f8 Dauer in Tagen $taged "  // zu Testzwecken
#        . " - gefixt auf ".$ft->tag.".".$ft->monat.".".$ft->jahr;                               // ggf. ausgeben
      }
      $f6 = $ft->tag;
      $f7 = $ft->monat;
      $f8 = $ft->jahr;
   }
   
        
   $f17 = "->OL!"              // Kennzeichen:        ->OL!    Dieser Termin stammt aus Outlook 
        . $data[7] . "!"       // ReminderMinutes
        . " " . $data[8]       // Categories
        . " " . $data[9]       // Importance
        . " " . $data[10]      // MeetingStatus
        . " " . $data[11]      // ResponseStatus
        . " " . $data[12];     // Sensitivity
        
   if ($data[10]!="") {
#     $meeting = "- Besprechungsstatus: ".$data[11]; // 
      $meeting = " - ".$data[11]; // 
   }  else {
      $meeting = "";
   }

   $f18 = $data[13]; // last modification date: tt.mm.jjjj hh:mm:ss
      
   if ($data[14]=="") { // Annahme: keine Serie, also
      $f1 = "F";        // Fix
      $f9 = "T";        // Taeglich
   }  else {

// Behandlung der Serientermine

// ... zunaechst die Ausnahmen (nur deleted)...
      if ($data[15]!="") {                                    // ausnahme vorhanden
         unset($ausnahmen);
         $ausnahmen = explode("^", $data[15]);                // einzelne Tage
         $x = count($ausnahmen);
         if ($x>0) {
            for ($c=0; $c < $x; $c++) {
                $ausnahmetag = explode("", $ausnahmen[$c]);
                if ($ausnahmetag[0]=="isDeleted"              // geloescht sowieso
                    OR $ausnahmetag[0]=="isModified") {       // modifiziert: Ausnahme hinzufuegen spaeter...
                   if ($f15!="") {
                      $f15 .= ",";
                   }
                   $f15 .= $ausnahmetag[1];
                }
            }
            
         }
      } // endif ausnahmen


// von-Datum und Bis-Datum ganz neu aus den Seriendatenfeldern bestimmen...
      $von       = explode(".", $data[16]);  // StartSerie (nur Datum)
      $f3 = $von[0]; // tag von
      $f4 = $von[1]; // monat von
      $f5 = $von[2]; // jahr von

      if ($data[17]=="AllDayEvent") {
         $zeit = "";
      }  else {
         $zeit = substr($data[17],0,5);
      }
   
      $bisdatuhr = explode(" ", $data[18]);
      $bis =     explode(".", $bisdatuhr[0]);
      $f6 = $bis[0]; // tag bis
      $f7 = $bis[1]; // monat bis
      $f8 = $bis[2]; // jahr bis
      if (isset($bisdatuhr[1])) {
         $zeit .= "-" . substr($bisdatuhr[1],0,5);
      }
      
      if ($f8==4500) {     // scheint das Outlook-Maximum-Jahr zu sein
         $f6 = "";
         $f7 = "";
         $f8 = "";
         $zeit = "";
      }


// OL-Besonderheiten je Serientyp (siehe - z.B. in VBA-Hilfe - AppointmentItem-Objekt-Doku) 
// umsetzen auf CSV-File-Besonderheiten (siehe http://galupki.de/kalender/feiertage.pdf)
// wobei einige Objekt-Eigenschaften schon durch das exportierende VBscript vorangepasst sind!

      switch ($data[19]) {
                 
      case "DAIYLY":
           $f1 = "F";        // Fix
           $f9 = "T";        // Taeglich
           break;
           
      case "PERIOD":
           $f1 = "P";        // periodisch
           $f2 = $data[20];  // periodizitt in Tagen
           $f9 = "T";        // Taeglich
           break;
           
      case "MONTHLY":
           if ($data[20]>1) {
              echo "\n<br />$lineno mtl. Termin mit Interval>1 nicht untersttzt";
              continue 2;
           }
           $f1 = "F";        // jhrlich einmal
           $f9 = "M";        // mtl
           break;
           
      case "YEARLY":
           $f1 = "F";        // jhrlich einmal
           $f3 = $data[21];  // tag
           $f4 = $data[20];  // monat
           $p1 = strpos($data[8],"Jahrestag");   // Erkennung via diesen Categories, beides NICHT Standard 
           $p2 = strpos($data[8],"Jubilum");
           if ($p1===false AND $p2===false) {
              $p = false;
           }  else {
              $p = true;
           }
           if (substr($f0,0,1)=="*"      //  Subject beginnt mit "*"=Jahrestag (besser z.B. via Kategorie...)
               OR $p==true) {            
              $f12 = "J";                // ausgabe Jahrestag / Jubilums-Jahre in Klammern
           }
           break;

      case "WEEKLY":     
           $f1 = "P";         // hamwa nicht, wird periodischer Termin
           $f2 = $data[20]*7; // woechentlich - jede n.te Woche (1, 2, 3...)
           $f9 = "T";         // Taegl.
           $f0 = $zeit . " " . $f0 . " " . $meeting; // hh:mm{-hh:mm} subject [location] - Besprechung: responseStatus
           for ($c=0; $c<7; $c++) {                     // DayMask wird zu: Mo-So 1-7
               if ( substr($data[22], $c, 1)!="-" ) {
                  $savef3 = $f3;
                  $savef4 = $f4;
                  $savef5 = $f5;
                  $x = $ft->naechsterWotag($f5, $f4, $f3, $c+1); // erstes auftreten des $wotag am/nach Startdate
                  $f3 = $ft->tag;
                  $f4 = $ft->monat;
                  $f5 = $ft->jahr;
                  schreib_satz();  // Regel fuer diesen Wochentag sichern
                  $f3 = $savef3;
                  $f4 = $savef4;
                  $f5 = $savef5;
               }
           }
           break;

      case "MONTHLYnTH": 
           if ($data[20]>1) {
              echo "\n<br />$lineno mtl. Termin mit Interval>1 nicht untersttzt";
              continue 2;
           }
           $f1 = "T";
           $f3 = $data[21];
           $f9 = "M";
           break;

      case "YEARLYnTH": 
           $f1 = "T";
           $f3 = $data[21];
           $f4 = $data[20];
           $f9 = "";
           break;
           
      default:
           echo "\n<br />$lineno Fehler: unbekannter Serientyp: ".$data[19];
           continue 2; // unbekannte Serienart!
           break;
      }


   } // endif Serie


// den neuen Terminsatz wegschreiben
        $f0 = $zeit . " " . $f0 . " " . $meeting; // hh:mm{-hh:mm} subject [location] - Besprechung: responseStatus

        if ($data[19]=="MONTHLYnTH" OR $data[19]=="YEARLYnTH") {
// Sonderbehandlung, DayOfWeekMask
           schreib_je_wochentag($data[22]); 
        }  elseif ($data[19]=="WEEKLY") {
// Sonderbehandlung, bereits erledigt!
        }  else {
           schreib_satz();
        }

// ... jetzt noch alle modifizierten Ausnahmen nachholen und in einfache normale Termine umsetzen...
      if ($data[15]!="") {                                    // ausnahme vorhanden
         unset($ausnahmen);
         $ausnahmen = explode("^", $data[15]);                // einzelne Tage separieren

         $x = count($ausnahmen);
         if ($x>0) {
            for ($y=0; $y < $x; $y++) {
                $ausnahmetag = explode("", $ausnahmen[$y]);
                if ($ausnahmetag[0]=="isModified") {          // nur modifizierte Tage interessieren
                   $f1 = "F"; // nur fuer einen Tag
                   $f9 = "T";        
                   $f3 = substr($ausnahmetag[1],0,2);
                   $f4 = substr($ausnahmetag[1],3,2);
                   $f5 = substr($ausnahmetag[1],6,4);
                   $f6 = $f3;
                   $f7 = $f4;
                   $f8 = $f5;
                   $f15 = "";
                   $zeit = "";
                   if ($ausnahmetag[5]=="AllDayEvent") {
                      $zeit = "";
                   }  else {
                      $vondatuhr = explode(" ", $ausnahmetag[2]); // ab Uhrzeit...
                      if (isset($vondatuhr[1])) {
                         $zeit = substr($vondatuhr[1],0,5);
                      }
                      $bisdatuhr = explode(" ", $ausnahmetag[3]);  // bis Uhrzeit...
                      if (isset($bisdatuhr[1])
                          AND $vondatuhr[1]!=$bisdatuhr[1]) {
                         $zeit .= "-" . substr($bisdatuhr[1],0,5);
                      }
                   }
                   $f0 = $ausnahmetag[6];
                   if ($ausnahmetag[7]!="") {
                      $f0 .= " [" . $ausnahmetag[7] . "]"; // subject [Location]    also nicht alles!
                   }

// neuen modifizierten Terminsatz wegschreiben
                   $f0 = $zeit . " " . $f0; //// . " " . $meeting; // hh:mm{-hh:mm} subject [location]

                   schreib_satz();
                   
                }
            }
            
         }
      } // endif ausnahmen





  }  // endwhile
  
  pend_ergaenzen(); // Stze die online im Web erfasst wurden und anscheinend noch nicht im OL!

  fclose($old);
  fclose($new);

# Alte Datei wegwerfen.
  unlink($terminfile);
# Neue Datei umbenennen
  rename($terminfile.".new", $terminfile);

  echo "\n<p>$lineno Stze wurden bearbeitet.";
  echo "\n<br />$lineok Stze wurden geschrieben.</p> "; // wobei das Verhltnis 1:n sein kann!
  echo "\n<h3>Ende.</h3>";


// =================================================================================================


function schreib_satz() {
// implode der $f-Felder und einen Datensatz in die Ausgabedatei schreiben

 global $new, $debug, $lineno, $satz, $lineok, $pendinganz, $pending,
        $f0,  $f1,  $f2,  $f3,  $f4,  $f5,  $f6,  $f7,  $f8,  $f9,
        $f10, $f11, $f12, $f13, $f14, $f15, $f16, $f17, $f18;


   $newdata = "";
   for ($c=0; $c <= 18; $c++) {
       $vname = "f$c";
       $newdata .= trim($$vname) . ";";
   }
   $newdata = substr($newdata,0, strlen($newdata)-1); // letztes Semikolon wegwerfen
   $newdata .= "\r\n";                                // new line dranhaengen
   fputs($new, $newdata);                             // und wegschreiben
   $lineok++;
   
   if ($debug) {
      echo "<p>$lineno<br />ol: ". $satz ."<br />csv: ". $newdata;
   }
   
   
//testen: noch nicht in Outlook vorhandene Termine
   if ( $pendinganz <1 ) {
      return ;
   }
   
   foreach ($pending as $key => $satz ) {
      $xdata = explode(";", $satz);
      if ( 
           trim($xdata[0])==trim($f0)                 // subject  (Problem evtl.: Zeitraum, Location, Besprechung...)
           AND $xdata[1]=="F"                         // nur fixe Termine, sonst wirds komplizierter 
           AND $xdata[3]==$f3                         // Beginndatum muss bereinstimmen
           AND $xdata[4]==$f4   
           AND $xdata[5]==$f5   
         ) {
         unset($pending[$key]);                       // treffer
         $pendinganz--;
         echo "<p>$lineno<br />csv: ". $satz ." gelscht aus PENDING weil bermittelt aus OL...<br />csv->OL!: ". $newdata;
         continue;
      } // endif treffer
   }
   

}  // end function schreib_satz



function pend_ergaenzen() {
// hngt die anscheinend noch nicht im OL vorhandenen Terminstze wieder an die neue Datei dran

 global $pending, $new, $lineok, $debug;
 

//testen: noch nicht in Outlook vorhandene Termine
   if ( count($pending)<1 ) {
      return ;
   }
   echo "<p><strong>Bisher noch nicht im ->OL!</strong>...<pre>\n";
   foreach ($pending as $key => $satz ) {
      $satz = trim($satz) . "\r\n";                   // new line dranhaengen
      fputs($new, $satz);                             // und wegschreiben
      $lineok++;
      echo $satz;
   }
   echo "</pre></p>";

} //endfunction pend_ergaenzen



function schreib_je_wochentag($daymask) { 
// schreibt einen Satz je passendem Wochentag (anhand einer DayOfWeekMask)

 global $f2;

  for ($c=0; $c<7; $c++) { // wird zu: Mo-So 1-7
      if ( substr($daymask, $c, 1)!="-" ) {
         $f2 = $c+1;
         schreib_satz();
      }
  }

} // end function je_wochentag



?>
 
